create table bit_example (a bits, b bits);
copy bit_example from stdin;
X0F	X10
X1F	X11
X2F	X12
X3F	X13
X8F	X04
X000F	X0010
X0123	XFFFF
X2468	X2468
XFA50	X05AF
X1234	XFFF5
\.

select a,b,bit_length(a) as "bit_length(a)", 
	octet_length(a) as "octet_length(a)", 
	a||b as "a||b",bit_length(a||b) as "bit_length(a||b)"
	from bit_example;

select a,b, bitsubstr(a,4,4) as "sub(a,4,4)", 
	bitsubstr(b,2,3) as "sub(b,2,3)", 
	bitsubstr(b,5,7) as "sub(b,5,7)"
	from bit_example;
select a,b,~a as "~ a",a & b as "a & b", 
	a|b as "a | b", a^b as "a ^ b" from bit_example;
select a,b,a<b as "a<b",a<=b as "a<=b",a=b as "a=b",
        a>=b as "a>=b",a>b as "a>b",a<=>b as "a<=>b" from bit_example;
select a,a<<4 as "a<<4",b,b>>2 as "b>>2" from bit_example;
select a,b,a||b as "a||b", bitsubstr(a,4,4) as "sub(a,4,4)", 
	bitsubstr(b,2,4) as "sub(b,2,4)", 
	bitsubstr(b,5,5) as "sub(b,5,5)"
	from bit_example;

-- The following should fail
select 'X123'::bits & 'X12'::bits;
select 'B0111'::bits | 'B011'::bits;
select 'X023'::bits ^ 'B011101'::bits;

drop table bit_example;
